/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem C. Consonant Fencity                                   */
/*                                                                */
/* Original idea         Andrei Lopatin                           */
/* Problem statement     Andrei Lopatin                           */
/* Test set              Andrei Lopatin                           */
/******************************************************************/
/* Tests                                                          */
/*                                                                */
/* Author                Andrei Lopatin                           */
/******************************************************************/

import java.io.*;
import java.nio.file.*;
import java.util.*;

public class Tests {
    private static int nTests = 0;
    private static final Path root = Paths.get("tests");
    private static final Random random = new Random(54378957349857345L);
    static final String alph = "abcdefghijklmnopqrstuvwxyz";
    static final String cons = "bcdfghjklmnpqrstvxz";
    static final int K = cons.length ();
    static int MaxN = (int)1e6;

    public static void main(String[] args) throws IOException {
        Files.createDirectories(root);

        test("consonants");
        test("destruction");
        test("strength");
        test("a");
        test("b");
        test("abacabadabacaba");
        test("veryverylittlekitten");
        test(alph);
        test(cons);
        test(1000, alph);
        test(1000, cons);
        test(MaxN, alph);
        test(MaxN, cons);
        test(MaxN, cons);
        test(MaxN, cons);
        test(MaxN, "aeiouwy");
        test(MaxN, "a");
        test(MaxN, "z");
        test(MaxN, "xz");
        test(MaxN, "orly");
        for (int v = 2; v < 8; v++) {
          test(MaxN, cons, v);
          test(MaxN, alph, v);
        }
        for (int v = 1; v < 6; v++) {
          test (MaxN, cons);
        }
        for (int v = 2; v < 7; v++) {
          test (MaxN, new StringBuilder (cons).reverse ().toString (), v);
        }
        char c[] = new char[MaxN];
        for (int i = 0; i < MaxN; i++)
          c[i] = (i & 1) == 0 ? 'x' : 'z';
        test (new String (c));
        int v = (MaxN / K) * K;
        c = new char[v];
        for (int i = 0; i < v; i++) c[i] = cons.charAt (i % K);
        test (new String (c));
        c = new char[MaxN];
        for (int i = 0; i < MaxN; i++) c[i] = cons.charAt (i % K);
        test (new String (c));
    }


    
    static int randit (int k, int l) {
      for (int i = 0; i < l; i++) {
        k = random.nextInt (k) + 1;
      }
      return k - 1;
    }
    
    static void test(int n, String z, int v) {
      char c[] = new char [n];
      int k = z.length ();
      for (int i = 0; i < n; i++) 
        c[i] = z.charAt (randit (k, v));
      test (new String (c));
    }
    
    static void test(int n, String z) {
      test(n, z, 1);
    }


    private static void test(String s) {
        try (PrintWriter out = new PrintWriter(String.format("%s/%02d", root, ++nTests))) {
            System.out.println("Writing test " + nTests);
            out.println(s);
        } catch (IOException e) {
            throw new AssertionError(e);
        }
    }
}

