/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem D. Dividing Marbles                                    */
/*                                                                */
/* Original idea         Gennady Korotkevich                      */
/* Problem statement     Gennady Korotkevich                      */
/* Test set              Gennady Korotkevich                      */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.File;
import java.io.PrintWriter;
import java.util.*;

public class dividing_gk {
    private static Scanner in;
    private static PrintWriter out;

    private static class Solution {
        int read() {
            return 1 << in.nextInt();
        }
        int[][] chains;
        Map<Integer, List<Integer>> indices = new HashMap<>();
        int[] chain = new int[24];
        boolean[] use = new boolean[(1 << 22) + 1];

        void run() {
            int t = in.nextInt();
            for (int i = 0; i < t; i++) {
                final int n = read() + read() + read() + read();
                use[n] = true;
                indices.computeIfAbsent(n, k -> new ArrayList<>()).add(i);
            }

            chains = new int[t][];
            chain[0] = 1;
            find(1);
            for (int[] chain : chains) {
                out.println(chain.length - 1);
                for (int i = chain.length - 1; i >= 1; i--) {
                    out.println(chain[i] + " " + chain[i - 1] + " " + (chain[i] - chain[i - 1]));
                }
            }
        }

        private void find(final int i) {
//            System.out.println(Arrays.toString(Arrays.copyOf(chain, i)));
            if (chain[i - 1] >= use.length) {
                return;
            }
            if (use[chain[i - 1]]) {
                for (Integer ind : indices.get(chain[i - 1])) {
                    if (chains[ind] == null || chains[ind].length > i) {
                        chains[ind] = Arrays.copyOf(chain, i);
                    }
                }
            }
            if (i == chain.length) {
                return;
            }
//            System.out.println(i + " " + chain[i - 1] + " " + (1 << (i - 3)));
            if (i >= 3 && chain[i - 1] < 1 << (i - 3)) {
                return;
            }
            assert i < 4 || chain[i - 1] >= 1 << (i - 4);
            for (int j = i - 1; j >= 0; j--) {
                if (chain[j] * 2 <= chain[i - 1]) {
                    break;
                }
                for (int k = j; k > -1; k--) {
                    chain[i] = chain[k] + chain[j];
                    if (chain[i] > chain[i - 1]) {
                        find(i + 1);
                    } else {
                        break;
                    }
                }
            }
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("dividing.in"));
        out = new PrintWriter("dividing.out");

        new Solution().run();

        in.close();
        out.close();
    }
}

