/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem E. Equal Numbers                                       */
/*                                                                */
/* Original idea         Vitaly Aksenov                           */
/* Problem statement     Vitaly Aksenov                           */
/* Test set              Vitaly Aksenov                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Vitaly Aksenov                           */
/******************************************************************/

import java.io.BufferedReader;
import java.io.IOException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.StringTokenizer;

/**
 * Created by vaksenov on 30.09.2017.
 */
public class equal_va {
    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (st == null || !st.hasMoreElements()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public class Value implements Comparable<Value> {
        int x;
        int cnt;
        boolean covered;

        public Value(int x, int cnt) {
            this.x = x;
            this.cnt = cnt;
        }

        public int compareTo(Value v) {
            return cnt - v.cnt;
        }
    }

    public void cover(Value[] d) {
        boolean[] has = new boolean[1_000_001];
        for (Value v : d) {
            has[v.x] = true;
        }

        for (Value v : d) {
            int now = 2 * v.x;
            while (now < has.length) {
                if (has[now]) {
                    v.covered = true;
                    break;
                }
                now += v.x;
            }
        }
    }

    public void solve() throws IOException {
        long start = System.currentTimeMillis();
        int n = nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }

        Arrays.sort(a);

        ArrayList<Value> dList = new ArrayList<>();

        int now = a[0];
        int cnt = 1;
        for (int i = 1; i < n; i++) {
            if (a[i] == a[i - 1]) {
                cnt++;
            } else {
                dList.add(new Value(now, cnt));
                now = a[i];
                cnt = 1;
            }
        }
        dList.add(new Value(now, cnt));

        Value[] d = dList.toArray(new Value[dList.size()]);

        cover(d);

        ArrayList<Value> covered = new ArrayList<>();

        for (Value v : d) {
            if (v.covered) {
                covered.add(v);
            }
        }

        Collections.sort(covered);
        Collections.sort(dList);

        int[] ans1 = new int[n + 1];
        Arrays.fill(ans1, Integer.MAX_VALUE);
        ans1[0] = d.length;
        int current = 1;
        for (Value v : covered) {
            for (int i = 0; i < v.cnt - 1; i++) {
                ans1[current] = ans1[current - 1];
                current++;
            }
            ans1[current] = ans1[current - 1] - 1;
            current++;
        }

        for (int i = current; i < ans1.length; i++) {
            ans1[i] = ans1[i - 1];
        }

        int[] ans2 = new int[n + 1];
        Arrays.fill(ans2, Integer.MAX_VALUE);
        ans2[0] = d.length + 1;
        current = 1;
        for (Value v : dList) {
            for (int j = 0; j < v.cnt - 1; j++) {
                ans2[current] = ans2[current - 1];
                current++;
            }
            ans2[current] = ans2[current - 1] - 1;
            current++;
        }

        for (int i = 0; i < ans1.length; i++) {
            out.print((i == 0 ? "" : " ") + Math.min(ans1[i], ans2[i]));
        }
    }

    public void run() {
        try {
            long start = System.currentTimeMillis();
            br = new BufferedReader(new FileReader("equal.in"));
            out = new PrintWriter("equal.out");

            solve();

            out.close();
            System.out.println("total " + (System.currentTimeMillis() - start));
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new equal_va().run();
    }
}

