/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem H. Hidden Supervisors                                  */
/*                                                                */
/* Original idea         Niyaz Nigmatullin                        */
/* Problem statement     Niyaz Nigmatullin                        */
/* Test set              Niyaz Nigmatullin                        */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Pavel Kunyavskiy                         */
/******************************************************************/

#include <cstdio>
#include <vector>

using namespace std;

vector<int> p;
vector<vector<int>> g;

vector<int> clean;
vector<int> aclean;
int match;


bool dfs(int v) {
  bool res = true;
  for (int u : g[v]) {
    bool r = dfs(u);
    if (r) {
      if (res) {
        match++;
        res = false;
      } else {
        clean.push_back(u);
      }
    }
  }
  return res;
}

int main() {
  freopen("hidden.in", "r", stdin);
  freopen("hidden.out", "w", stdout);

  int n;
  scanf("%d", &n);
  p.resize(n);
  g.resize(n);
  p[0] = -1;
  for (int i = 1; i < n; i++) {
    scanf("%d", &p[i]);
    --p[i];
    if (p[i] != -1) {
      g[p[i]].push_back(i);
    }
  }

  for (int it = 0; it < 2; it++) {
    clean.clear();
    bool r = dfs(0);
    aclean = clean;
    if (r) {
      aclean.push_back(0);
    }
    for (int i = 1; i < n; i++) {
      if (p[i] == -1) {
        int last = aclean.empty() ? 0 : aclean.back();
        clean.clear();
        bool r = dfs(i);
        if (!r) last = 0;
        if (!clean.empty() || it) {
          p[i] = last;
          g[p[i]].push_back(i);
          if (!aclean.empty() && last == aclean.back()) {
            aclean.pop_back();
          } else if (r) {
            aclean.push_back(i);
          }
          aclean.insert(aclean.end(), clean.begin(), clean.end());
        }
      }
    }
  }

  match = 0;
  dfs(0);

  printf("%d\n", match);
  for (int i = 1; i < n; i++) {
    printf("%d ", p[i] + 1);
  }
  printf("\n");
  return 0;
}

