/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem K. Kotlin Island                                       */
/*                                                                */
/* Original idea         Mikhail Dvorkin                          */
/* Problem statement     Mikhail Dvorkin                          */
/* Test set              Mikhail Dvorkin                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.File;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class kotlin_gk {
    private static Scanner in;
    private static PrintWriter out;

    private static class Solution {
        void run() {
            Arrays.stream(solve(in.nextInt(), in.nextInt(), in.nextInt())).forEach(out::println);
        }

        private String[] solve(final int h, final int w, final int n) {
            for (int r = 1; r <= (h + 1) / 2; r++) {
                for (int c = 1; c <= (w + 1) / 2; c++) {
                    if (c * r == n) {
                        return ok(h, w, r, c);
                    }
                }
            }
            return new String[]{"Impossible"};
        }

        private String[] ok(final int h, final int w, final int cr, final int cc) {
            final char[][] result = new char[h][w];
            for (int r = 0; r < h; r++) {
                for (int c = 0; c < w; c++) {
                    result[r][c] = c % 2 == 1 && c < cc * 2 - 1 || r % 2 == 1 && r < cr * 2 - 1 ? '#' : '.';
                }
            }
            return Arrays.stream(result).map(String::new).toArray(String[]::new);
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("kotlin.in"));
        out = new PrintWriter("kotlin.out");

        new Solution().run();

        in.close();
        out.close();
    }
}

