/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem K. Kotlin Island                                       */
/*                                                                */
/* Original idea         Mikhail Dvorkin                          */
/* Problem statement     Mikhail Dvorkin                          */
/* Test set              Mikhail Dvorkin                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Mikhail Dvorkin                          */
/******************************************************************/

import java.io.*;
import java.util.*;

public class kotlin_md {
	public static final String IMPOSSIBLE = "Impossible";
	public static final char DRY_LAND = '.';
	public static final char WATER = '#';

	public void run() {
		int h = in.nextInt();
		int w = in.nextInt();
		int n = in.nextInt();
		int hMax = (h + 1) / 2;
		int wMax = (w + 1) / 2;
		for (int i = 0; i <= hMax; i++) {
			int j = i == 0 ? 0 : n / i;
			if (i * j == n & j <= wMax) {
				output(h, w, i, j);
				return;
			}
		}
		out.println(IMPOSSIBLE);
	}

	void output(int h, int w, int a, int b) {
		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				if (i % 2 == 0 && i / 2 < a && j % 2 == 0 && j / 2 < b) {
					out.print(DRY_LAND);
				} else {
					out.print(WATER);
				}
			}
			out.println();
		}
	}

	static Scanner in;
	static PrintWriter out;

	public static void main(String[] args) throws IOException {
		String fileName = kotlin_md.class.getSimpleName().replaceFirst("_.*", "").toLowerCase();
		String inputFileName = fileName + ".in";
		String outputFileName = fileName + ".out";

		in = new Scanner(new File(inputFileName));
		out = new PrintWriter(outputFileName);
		new kotlin_md().run();
		in.close();
		out.close();
	}
}

