/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem L. Little Difference                                   */
/*                                                                */
/* Original idea         Dmitry Yakutov                           */
/* Problem statement     Pavel Kunyavskiy                         */
/* Test set              Pavel Kunyavskiy                         */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;
import java.util.stream.LongStream;

public class little_gk {
    private static Scanner in;
    private static PrintWriter out;

    private static class Solution {
        void run() {
            final List<List<Long>> answer = solve(in.nextLong());
            if (answer.isEmpty()) {
                out.println(-1);
            } else {
                out.println(answer.size());
                for (List<Long> row : answer) {
                    out.print(row.size());
                    for (long i : row) {
                        out.print(" " + i);
                    }
                    out.println();
                }
            }
        }

        private List<List<Long>> solve(final long n) {
            if (Long.bitCount(n)== 1) {
                return Collections.emptyList();
            }
            List<List<Long>> result = new ArrayList<>();
            result.add(Collections.singletonList(n));
            long p2 = 1;
            int p = 1;
            while (p2 < n / 2) {
                p2 *= 2;
                p++;
                final long a = (long) Math.pow(n, 1.0 / p);
                long[] pa = powers(a, p);
                assert pa[p] <= n;
                long[] pa1 = powers(a + 1, p);
                for (int i = 0; i <= p; i++) {
                    if (pa[i] * pa1[p - i] == n) {
                        List<Long> row = new ArrayList<>();
                        row.addAll(Collections.nCopies(i, a));
                        row.addAll(Collections.nCopies(p - i, a + 1));
                        result.add(row);
                    }
                }
            }
            return result;
        }

        private long[] powers(final long a, final int p) {
            return LongStream.iterate(1L, v -> v * a).limit(p + 1).toArray();
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("little.in"));
        out = new PrintWriter("little.out");

        new Solution().run();

        in.close();
        out.close();
    }
}

