/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem L. Little Difference                                   */
/*                                                                */
/* Original idea         Dmitry Yakutov                           */
/* Problem statement     Pavel Kunyavskiy                         */
/* Test set              Pavel Kunyavskiy                         */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.File;
import java.io.PrintWriter;
import java.util.*;

public class little_gk_ok_off_minus {
    private static Scanner in;
    private static PrintWriter out;

    private static class Solution {
        void run() {
            final Collection<List<Long>> answer = solve(in.nextLong());
            if (answer.isEmpty()) {
                out.println(-1);
            } else {
                out.println(answer.size());
                for (List<Long> row : answer) {
                    out.print(row.size());
                    for (long i : row) {
                        out.print(" " + i);
                    }
                    out.println();
                }
            }
        }

        private Collection<List<Long>> solve(final long n) {
            if (Long.bitCount(n)== 1) {
                return Collections.emptyList();
            }
            Set<List<Long>> result = new HashSet<>();
            result.add(Collections.singletonList(n));
            int p = 1;
            while (true) {
                p++;
                final long a = (long) Math.pow(n - 1, 1.0 / p);
                if (a == 1) {
                    break;
                }
                List<Long> row = new ArrayList<>();
                long r = n;
                while (r % a == 0) {
                    row.add(a);
                    r /= a;
                }
                while (r % (a + 1) == 0) {
                    row.add(a + 1);
                    r /= (a + 1);
                }
                if (r == 1) {
                    result.add(row);
                }
            }
            return result;
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("little.in"));
        out = new PrintWriter("little.out");

        new Solution().run();

        in.close();
        out.close();
    }
}

